=== third_party/CMakeLists.txt ===
add_subdirectory(nlohmann_json)
add_subdirectory(fmt)
add_subdirectory(spdlog)
add_subdirectory(grpc)

if (ENABLE_UNIT_TESTS)
    add_subdirectory(googletest)
else ()
    add_custom_target(googletest_dependency)
endif ()
