=== debian/changelog ===
bear (3.1.6-1) unstable; urgency=medium

  * New upstream version 3.1.6
  * debian/control: Bump Standards-Version

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 03 Apr 2025 13:25:20 +0200
